#include "gui_main.h"
#include <QCloseEvent>



QPointer<Gui_Main> Gui_Main::_self = 0L;

Gui_Main* Gui_Main::self( QWidget* parent )
{
	if ( !_self )
		_self = new Gui_Main( parent );
	return _self;
}

Gui_Main::Gui_Main( QWidget* parent )
	: QMainWindow( parent )
{
	setupUi( this );
	connect(builders, SIGNAL(clicked()), this , SLOT(Build_Class()));
	connect(dego, SIGNAL(clicked()), this , SLOT(DecodeGo()));
	connect(engo, SIGNAL(clicked()), this , SLOT(EncodeGo()));
}




void Gui_Main::Build_Class()
{
	QString header1, header2, nheader, nheader1, source1, nsource;
	QString brl = "\n";
	QString subclass = modus->currentText();
	QString classname = classnam->text();
	QString Cl_upper = classname.toUpper();
	QString Cl_lower = classname.toLower();
	QString FILENAMEH = Cl_upper + "_H";
	QTextStream hh1( &header1,QIODevice::WriteOnly);
    QTextStream hh2( &header2,QIODevice::WriteOnly);
    QTextStream ss1( &source1,QIODevice::WriteOnly);
	QString FILEh = Cl_lower + ".h";
	QString FILEc = Cl_lower + ".cpp";
	
	/* header file h */
	hh1 << "#ifndef " << FILENAMEH << brl;
	hh1 << "#define " << FILENAMEH<< brl;
	hh1 << "//" << brl;
	hh1 << "#include \"ui_" <<  FILEh << "\""<< brl;
    hh1 << "#include \"main.h\""<< brl;
	hh1 << "//"<< brl;
	hh1 << "/*  Save file as " <<  Cl_lower << ".h  */"<< brl;
	hh1 << "/*  incomming class name " << classname << " */"<< brl;
	hh1 << "//"<< brl;
	hh1 << "#include <QPointer>"<< brl;
	hh1 << "//"<< brl;
	hh1 << "class " << classname << " : public " << subclass << ", public Ui::" << classname << brl;
	hh1 << "{"<< brl;
	hh1 << "     Q_OBJECT"<< brl;
	hh1 << "//"<< brl;
	hh1 << "public:";
	hh1 << "\t static " << classname << "* self( QWidget* = 0 );"<< brl;
	hh1 << "//"<< brl;
	hh1 << "protected:";
	hh1 << "\t void closeEvent( QCloseEvent* );"<< brl;
	hh1 << "//"<< brl;
	hh1 << "private:"<< brl;
	hh1 << " " << classname << "( QWidget* = 0 );"<< brl;
	hh1 << " static QPointer<" << classname << "> _self;"<< brl;
	hh1 << " void Load_Connector();"<< brl;
	hh1 << "signals:"<< brl;
	hh1 << ""<< brl;
	hh1 << "public slots:"<< brl;
	hh1 << ""<< brl;
	hh1 << "};"<< brl;
	hh1 << "//"<< brl;
	hh1 << "#endif // " << FILENAMEH << brl << brl;
    /* source file cpp */
    ss1 << "#include \""<< FILEh << "\"" << brl;
    ss1 << "//"<< brl;
    ss1 << "/*  Save file as "<< FILEc << "  */"<< brl;
    ss1 << "/*  incomming class name " << classname << " */"<< brl;
    ss1 << "//"<< brl;
    ss1 << "#include <QCloseEvent>"<< brl;
    ss1 << "//"<< brl;
    ss1 << "QPointer<" << classname << "> " << classname << "::_self = 0L;"<< brl;
    ss1 << "//"<< brl;
    ss1 << "" << classname << "* " << classname << "::self( QWidget* parent )"<< brl;
    ss1 << "{"<< brl;
    ss1 << "\tif ( !_self )"<< brl;
    ss1 << "\t_self = new " << classname << "( parent );"<< brl;
    ss1 << "\treturn _self;"<< brl;
    ss1 << "}"<< brl;
    ss1 << "//"<< brl;
    ss1 << "" << classname << "::" << classname << "( QWidget* parent )"<< brl;
    ss1 << "	: " << subclass << "( parent )"<< brl;
    ss1 << "{"<< brl;
    ss1 << "	setupUi( this );"<< brl;
    ss1 << "	Load_Connector();"<< brl;
    ss1 << "}"<< brl;
    ss1 << "//"<< brl;
    ss1 << "void " << classname << "::Load_Connector()"<< brl;
    ss1 << "{"<< brl;
    ss1 << "/* to nothing */"<< brl;
    ss1 << "/*connect(buttonx, SIGNAL(clicked()), this , SLOT(Make()));*/"<< brl;
    ss1 << "}"<< brl << brl;
    ss1 << "void " << classname << "::closeEvent( QCloseEvent* e )"<< brl;
    ss1 << "{"<< brl;
    ss1 << "\te->accept();"<< brl;
    ss1 << "}"<< brl << brl;
    
    hh2 << "#ifndef " << FILENAMEH << brl;
	hh2 << "#define " << FILENAMEH<< brl;
	hh2 << "//" << brl;
	hh2 << "#include \"ui_" <<  FILEh << "\""<< brl;
    hh2 << "#include \"main.h\""<< brl;
	hh2 << "//"<< brl;
	hh2 << "/*  Save file as " <<  Cl_lower << ".h  */"<< brl;
	hh2 << "/*  incomming class name " << classname << " */"<< brl;
	hh2 << "//"<< brl;
	hh2 << "#include <QPointer>"<< brl;
	hh2 << "//"<< brl;
	hh2 << "class " << classname << " : public " << subclass << ", public Ui::" << classname << brl;
	hh2 << "{"<< brl;
	hh2 << "    Q_OBJECT"<< brl;
	hh2 << "//"<< brl;
	hh2 << "public:";
	hh2 << " " << classname << "( QWidget* = 0 )"<< brl;
	hh2 << "{"<< brl;
    hh2 << " setupUi( this );"<< brl;
    hh2 << " Load_Connector();"<< brl;
    hh2 << "}"<< brl;
	hh2 << "protected:"<< brl;
	hh2 << " void closeEvent( QCloseEvent* )"<< brl;
	hh2 << "{"<< brl;
    hh2 << " e->accept();"<< brl;
    hh2 << "}"<< brl;
	hh2 << "private:"<< brl;
	hh2 << " void Load_Connector()"<< brl;
    hh2 << "{"<< brl;
    hh2 << "/*connect(buttonx, SIGNAL(clicked()), this , SLOT(Make()));*/"<< brl;
    hh2 << "}"<< brl;
	hh2 << "signals:"<< brl;
	hh2 << ""<< brl;
	hh2 << "public slots:"<< brl;
	hh2 << ""<< brl;
	hh2 << "};"<< brl;
	hh2 << "//"<< brl;
	hh2 << "#endif // " << FILENAMEH << brl << brl;
    
	nsource = ss1.readAll();
	nheader = hh1.readAll();
    nheader1 = hh2.readAll();
    
    app_one->setLineWrapMode( QTextEdit::NoWrap );
	app_one->clear();
	app_one->insertPlainText(nheader1); 
    app_one->toPlainText();
    
    
	app_source->setLineWrapMode( QTextEdit::NoWrap );
	app_source->clear();
	app_source->insertPlainText(nsource); 
    app_source->toPlainText();
    
    
	app_header->setLineWrapMode( QTextEdit::NoWrap );
	app_header->clear();
	app_header->insertPlainText(nheader); 
    app_header->toPlainText();
	
	
	
}

void Gui_Main::DecodeGo()
{
    resu->clear();
    QByteArray xcode("");;
    xcode.append(decodein->document()->toPlainText());
    QByteArray precode(QByteArray::fromBase64(xcode));
    QString txt = precode.data();
    resu->insertPlainText(txt); 
    resu->toPlainText();
}

void Gui_Main::EncodeGo()
{
    resu->clear();
    QByteArray text;
    text.append(basein->document()->toPlainText());
    QString txt = text.toBase64();
    resu->insertPlainText(txt); 
    resu->toPlainText();
	
}


void Gui_Main::closeEvent( QCloseEvent* e )
{
	e->accept();
}
